

// Written by Aleksandar Maćašev as a part of the Chromapost project. www.chromapost.com
// Do not copy the code without permission. Contact me at macasev@gmail.com. I'm more than willing to grant permission.





import java.io.File;
import arb.soundcipher.*;

SoundCipher sc = new SoundCipher(this);


float re, g, b, pitch1, pitch2, pitch3, pitch1a, pitch2a, pitch3a;

float low=21; //lowest pitch
float high=108; //highest pitch

float fr=10; // framerate


PImage img;
PImage footer;
PImage play;
PImage pause;

// drawing the main matrix
float y, x;
float u=10; //step by x
float v= 10; // step by y
float w=10; //unit width
float h=10; //unit height
int s=80; // cells in a row
int r=60; // number of rows 

// reading colors from reformatted photo
float y1, x1;
float u1=1; //step by x
float v1= 1; // step by y
float w1=1; //unit width
float h1=1; //unit height


float y2, x2;


int colnum=s*r; // total number of colors

color[] c = new color[colnum]; //array of all the pixels from the photo

int count=0; // main count after each draw loop. going through all the colors in c array. starts from 0 when reaches the end of the array
int ccount; // play/pause switch. if 

// main image dimensions and ratio
float imw;
float imh;
float rat; // image ratio
float ratm=0.75; // main ratio 4:3





//====================================================================





void setup(){
  
 size(801, 800);
 background(255);
 
 footer=loadImage("footer.png");
 play=loadImage("play.png");
 pause=loadImage("pause.png");
 image(footer, 0, 750);
 image(play, 14, 764);
 image(pause, 50, 764);

//fill(255);
//rect(0, 0, width, height);

ccount=1; //play/pause switch count

}





//====================================================================


   



void draw(){
frameRate(fr);

// formating the image  
 if (img!=null) { // only of the image is selected
 
    // calculating based on ratio 4:3, 0.75
    imw=img.width;
    imh=img.height;
    rat=imh/imw;
    
    // if loaded image is exactly 4:3
    if(rat==ratm){
    image(img, 0, 0, s, r);  
    }
    
    // if loaded image is towards square or portrait
    if(rat>ratm){
    int iw=s; // width is 80
    int ih=int(iw*rat); // sizing the height proportionally
    int dif = int((ih-r)/2); //center the photo
    image(img, 0, -dif, iw, ih);
    }
    
    //if loaded image is wider than 4:3
    if(rat<ratm){
    int ih=r; // height is 60  
    int iw=int(ih/rat);
    int dif = int((iw-s)/2); // center the photo
    image(img, -dif, 0, iw, ih);
    }




//reading colors
for(int i=0; i<(s*r); i++){
     x1=i*u1; 
     //makes a jump for each row
     for(int j=0; j<r+1; j++){
    if(i>=(j*s) && i<((j+1)*s)){
      y1=j*v1;
      x1=x1-(u1*(j*s));
}
     }
c[i] = get(int(x1), int(y1));
  }
  
 
  //println(fr);
  
  // enlarged photo
 
  for(int i=0; i<(s*r); i++){
     x=i*u; 
     //makes a jump for each row
     for(int j=0; j<r+1; j++){
    if(i>=(j*s) && i<((j+1)*s)){
      y=j*v;
      x=x-(u*(j*s));
}
     }
    stroke(0);
    fill(c[i]);
    rect(x, y, w, h);
  }

 
//counting squares  
x2=count*u; 
     //makes a jump for each row
     for(int j=0; j<r+1; j++){

    if(count>=(j*s) && count<((j+1)*s)){
      y2=j*v;
      x2=x2-(u*(j*s));
}
     }
  noFill();
  stroke(255);
  rect(x2, y2, w-1, h-1);




//lower color field
noStroke();
fill(c[count]);
rect(0, 601, width, 149);



if(ccount%2==0){ // if switch is play
//play chords

re=red(c[count]);
g=green(c[count]);
b=blue(c[count]);

pitch1=map(re, 0, 255, low, high);
pitch2=map(g, 0, 255, low, high);
pitch3=map(b, 0, 255, low, high);

pitch1a=float(round(pitch1));
pitch2a=float(round(pitch2));
pitch3a=float(round(pitch3));

float []pitches = {pitch1a, pitch2a, pitch3a};

sc.playChord(pitches, 50, 0.3);



// main count
count = count +1;
if(count == (s*r)){
count=0;
} 
}


}
}





//====================================================================


   



// key actions
void keyPressed(){
// increase or decrease framerate  
  if(key=='+'){
    fr=fr+1;
  
  }
  
  if(key=='-'){
    fr=fr-1;
  
  }
}





//====================================================================


   


void mousePressed(){
  
  if(img!=null){
    
    // mouse action. choose square
  if((mouseY>=0 && mouseY <=h*r)){
 count=((floor(mouseY/u))*s)+(floor(mouseX/u)); 
  if(count >= (s*r)){
count=count-r;
}
  }
  //play and pause buttons
    if((mouseX>=14 && mouseX <=36) && (mouseY>=764 && mouseY<=786)){
    ccount=2;

  }
  
  if((mouseX>=50 && mouseX <=72) && (mouseY>=764 && mouseY<=786)){
    ccount=1;
   
  }
  

}
}





//====================================================================


   

// loading photo
void chooseFolder() {
  File folderToStartFrom = new File( "D://*.*" );
  selectInput("Select an image ", "folderSelected", folderToStartFrom );
}
//
void folderSelected(File selection) {
  // this runs in another thread parallel to the main thread
  if (selection == null) {
    println("Window was closed or Load Image was cancelled.");
  }
  else {
    println("You selected " + selection.getAbsolutePath());
    img=loadImage(  selection.getAbsolutePath()   );
  }
}

void mouseReleased() {
  if((mouseX>=707 && mouseX<=787)&&(mouseY>=764 && mouseY<=786)){
  chooseFolder();

  }
}